﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr118_3
{
    // Класс с перегрузкой операторов приведения типа: 
    class MyClass
    {
        public String text; // Текстовое поле 
        // Конструктор с тремя аргументами: 
        public MyClass(String t)
        {
            text = t;  // Значение текстового поля
        }

        // Переопределение метода ToString(): 
        public override String ToString()
        {
            // Локальная текстовая строка:
            String txt = "Teкстовое поле: \"" + text + "\"";
            // Результат метода: 
            return txt;
        }

        // Метод для явного приведения к типу int: 
        public static explicit operator int(MyClass obj)
        {
            return obj.text.Length;
        }

        // Метод для явного приведения к типу char: 
        public static explicit operator char(MyClass obj)
        {
            return obj.text[0];
        }

        // Метод для явного преобразования из типа int: 
        public static explicit operator MyClass(int n)
        {
            String s = "";
            for (int i = 0; i < n; i++)
                s += "A";
            MyClass t = new MyClass(s);
            return t;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объектов и проверка результата.
            // Явное создание объекта:
            MyClass A = new MyClass("Alpha");
            // Неявно вызывается метод ToString():
            Console.WriteLine("Объект А. " + A);
            // Явное преобразование в тип int:
            Console.WriteLine("Число: " + (int)A);
            // Явное преобразование в тип char:
            Console.WriteLine("Символ: " + (char)A);
            // Создание объекта преобразованием из типа int: 
            MyClass B = (MyClass)10;
            // Неявно вызывается метод ToString():
            Console.WriteLine("Объект В. " + B);
            // Задержка:
            Console.ReadLine();
        }
    }
}
